VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} URecent 
   Caption         =   "Recent Files"
   ClientHeight    =   6540
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   9510
   OleObjectBlob   =   "URecent.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "URecent"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Public Sub FillFilesAndPlaces(Optional sFilter As String = vbNullString)
    
    Dim dcPlaces As Scripting.Dictionary
    Dim rf As RecentFile
    Dim sPlace As String
    Dim sFile As String
    Dim aFiles() As String
    Dim lCnt As Long
    
    Set dcPlaces = New Scripting.Dictionary
    
    ReDim aFiles(1 To 2, 1 To 1)
    
    
    For Each rf In Application.RecentFiles
        sFile = Dir(rf.Name)
        sPlace = Replace(rf.Path, Dir(rf.Path), vbNullString)
        
        'If file isn't found, don't include it
        If Len(sFile) > 0 Then
            'Put file names and paths in an array
            If UCase(sFile) Like "*" & UCase(sFilter) & "*" Then
                lCnt = lCnt + 1
                ReDim Preserve aFiles(1 To 2, 1 To lCnt)
                aFiles(1, lCnt) = rf.Path
                aFiles(2, lCnt) = sFile
            End If
            
            'Put unique paths in a dictionary
            If UCase(sPlace) Like "*" & UCase(sFilter) & "*" Then
                If Not dcPlaces.Exists(sPlace) Then
                    dcPlaces.Add sPlace, sPlace
                End If
            End If
            
        End If
    Next rf
    
    'If files match, put to listbox, otherwise clear
    If lCnt = 1 Then
        Me.lbxFiles.Clear
        Me.lbxFiles.AddItem aFiles(1, 1)
        Me.lbxFiles.List(Me.lbxFiles.ListCount - 1, 1) = aFiles(2, 1)
    ElseIf lCnt > 1 Then
        Me.lbxFiles.List = Application.WorksheetFunction.Transpose(aFiles)
    Else
        Me.lbxFiles.Clear
    End If
    
    'Write keys array to places listbox
    Me.lbxPlaces.List = dcPlaces.Keys
    
End Sub

Private Sub cmdClose_Click()
    
    Unload Me
    
End Sub

Private Sub cmdNav_Click()
    
    Application.Dialogs(xlDialogOpen).Show
    Unload Me
    
End Sub

Private Sub cmdOpen_Click()
    
    Dim wb As Workbook
    
    If Me.lbxFiles.ListIndex > -1 Then
        On Error Resume Next
            Set wb = Workbooks(Me.lbxFiles.Column(1))
        On Error GoTo 0
        
        If wb Is Nothing Then
            Workbooks.Open Me.lbxFiles.Value
        Else
            wb.Activate
        End If
    Else
        ChDrive Left$(Me.lbxPlaces.Value, 3)
        ChDir Me.lbxPlaces.Value
        Application.Dialogs(xlDialogOpen).Show
    End If
           
    Unload Me
    
End Sub

Private Sub lbxFiles_Change()
    
    If Me.lbxFiles.ListIndex > -1 Then
        Me.tbxFullname.Text = Me.lbxFiles.Value
        Me.lbxPlaces.ListIndex = -1
    Else
        Me.tbxFullname.Text = vbNullString
    End If
    
    EnableOpen
    
End Sub

Private Sub lbxFiles_Enter()
    
    If Me.lbxFiles.ListIndex = -1 And Me.lbxFiles.ListCount > 0 Then
        Me.lbxFiles.ListIndex = 0
    End If
    
End Sub

Private Sub lbxPlaces_Change()
    
    If Me.lbxPlaces.ListIndex > -1 Then
        Me.lbxFiles.ListIndex = -1
    End If
    
    EnableOpen
    
End Sub

Private Sub lbxPlaces_Enter()
    
    If Me.lbxPlaces.ListIndex = -1 And Me.lbxPlaces.ListCount > 0 Then
        Me.lbxPlaces.ListIndex = 0
    End If
    
End Sub

Private Sub tbxSearch_Change()
    
    FillFilesAndPlaces Me.tbxSearch.Text
    
End Sub

Private Sub UserForm_Initialize()
    
    FillFilesAndPlaces
    EnableOpen
    
End Sub

Public Sub EnableOpen()
    
    Dim wb As Workbook
    
    Me.cmdOpen.Enabled = False
    
    If Me.lbxPlaces.ListIndex > -1 Then
        Me.cmdOpen.Enabled = True
    ElseIf Me.lbxFiles.ListIndex > -1 Then
        On Error Resume Next
            Set wb = Workbooks(Me.lbxFiles.Column(1))
        On Error GoTo 0
        
        If wb Is Nothing Then
            Me.cmdOpen.Enabled = True
        Else
            If wb.FullName = Me.lbxFiles.Value Then
                Me.cmdOpen.Enabled = True
            Else
                Me.tbxFullname.Text = Me.tbxFullname.Text & Space(1) & "(naming conflict)"
            End If
        End If
    End If
    
End Sub
